c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine c_c_hd (hamil,dhamil)
c
      implicit none
      character*5 tc
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3)
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
      double precision sps0,   spsna,spsnb,   spsnc,sps,dsps
      double precision pss0,   pssna,pssnb,   pssnc,pss,dpss
      double precision pps0,   ppsna,ppsnb,   ppsnc,pps,dpps
      double precision ppp0,   pppna,pppnb,   pppnc,ppp,dppp
c
c Hopping parameters for carbon-hydrogen from Wang and Mak.
c
      DATA r0 /1.312d0/
      DATA rt /2.d0/
c s s sigma
      DATA sss0 /-7.948d0/
      DATA sssna /1.29827d0/
      DATA sssnb /1.d0/
      DATA sssnc /5.d0/
c s p sigma
      DATA sps0 /7.413d0/
      DATA spsna /0.99055d0/
      DATA spsnb /1.d0/
      DATA spsnc /5.d0/
c p s sigma
      DATA pss0 /-7.413d0/
      DATA pssna /0.99055d0/
      DATA pssnb /1.d0/
      DATA pssnc /5.d0/
c p p sigma
      DATA pps0 /6.224d0/
      DATA ppsna / 1.01545d0/
      DATA ppsnb /1.d0/
      DATA ppsnc /5.d0/
c p p pi
      DATA ppp0 /-2.980d0/
      DATA pppna / 1.8246d0/
      DATA pppnb /1.d0/
      DATA pppnc /5.d0/
c  
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
      call wangma(sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)
      call wangma(sps0,r0,spsna,spsnb,rt,spsnc,sps,dsps)
      call wangma(pss0,r0,pssna,pssnb,rt,pssnc,pss,dpss)
      call wangma(pps0,r0,ppsna,ppsnb,rt,ppsnc,pps,dpps)
      call wangma(ppp0,r0,pppna,pppnb,rt,pppnc,ppp,dppp)
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxyz('x',sps,dsps,t,dt)       !s-px
      hamil(1,2)=t
      dhamil(1,2,1)=dt(1)
      dhamil(1,2,2)=dt(2)
      dhamil(1,2,3)=dt(3)

      call sxyz('y',sps,dsps,t,dt)       !s-py
      hamil(1,3)=t
      dhamil(1,3,1)=dt(1)
      dhamil(1,3,2)=dt(2)
      dhamil(1,3,3)=dt(3)

      call sxyz('z',sps,dsps,t,dt)       !s-pz
      hamil(1,4)=t
      dhamil(1,4,1)=dt(1)
      dhamil(1,4,2)=dt(2)
      dhamil(1,4,3)=dt(3)

      call sxyz('x',pss,dpss,t,dt)       !px-s
      hamil(2,1)=t
      dhamil(2,1,1)=dt(1)
      dhamil(2,1,2)=dt(2)
      dhamil(2,1,3)=dt(3)

      call xx('x',pps,dpps,ppp,dppp,t,dt)   !px-px
      hamil(2,2)=t
      dhamil(2,2,1)=dt(1)
      dhamil(2,2,2)=dt(2)
      dhamil(2,2,3)=dt(3)

      call xy('xy',pps,dpps,ppp,dppp,t,dt)  !px-py
      hamil(2,3)=t
      dhamil(2,3,1)=dt(1)
      dhamil(2,3,2)=dt(2)
      dhamil(2,3,3)=dt(3)

      call xy('xz',pps,dpps,ppp,dppp,t,dt)  !px-pz
      hamil(2,4)=t
      dhamil(2,4,1)=dt(1)
      dhamil(2,4,2)=dt(2)
      dhamil(2,4,3)=dt(3)

      call sxyz('y',pss,dpss,t,dt)          !py-s
      hamil(3,1)=t
      dhamil(3,1,1)=dt(1)
      dhamil(3,1,2)=dt(2)
      dhamil(3,1,3)=dt(3)

      call xy('xy',pps,dpps,ppp,dppp,t,dt)  !py-px
      hamil(3,2)=t
      dhamil(3,2,1)=dt(1)
      dhamil(3,2,2)=dt(2)
      dhamil(3,2,3)=dt(3)

      call xx('y',pps,dpps,ppp,dppp,t,dt)   !py-py
      hamil(3,3)=t
      dhamil(3,3,1)=dt(1)
      dhamil(3,3,2)=dt(2)
      dhamil(3,3,3)=dt(3)

      call xy('yz',pps,dpps,ppp,dppp,t,dt)  !py-pz
      hamil(3,4)=t
      dhamil(3,4,1)=dt(1)
      dhamil(3,4,2)=dt(2)
      dhamil(3,4,3)=dt(3)

      call sxyz('z',pss,dpss,t,dt)          !pz-s
      hamil(4,1)=t
      dhamil(4,1,1)=dt(1)
      dhamil(4,1,2)=dt(2)
      dhamil(4,1,3)=dt(3)

      call xy('xz',pps,dpps,ppp,dppp,t,dt)  !pz-px
      hamil(4,2)=t
      dhamil(4,2,1)=dt(1)
      dhamil(4,2,2)=dt(2)
      dhamil(4,2,3)=dt(3)

      call xy('yz',pps,dpps,ppp,dppp,t,dt)  !pz-py
      hamil(4,3)=t
      dhamil(4,3,1)=dt(1)
      dhamil(4,3,2)=dt(2)
      dhamil(4,3,3)=dt(3)

      call xx('z',pps,dpps,ppp,dppp,t,dt)   !pz-pz
      hamil(4,4)=t
      dhamil(4,4,1)=dt(1)
      dhamil(4,4,2)=dt(2)
      dhamil(4,4,3)=dt(3)

      return
      end
