c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine c_h_hd (hamil,dhamil)
c
      implicit none
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3)
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
      double precision pss0,   pssna,pssnb,   pssnc,pss,dpss
c
c Hopping parameters for carbon-hydrogen from Wang ang Mak.
c
      DATA r0 /1.09d0/
      DATA rt /2.d0/
c s s sigma
      DATA sss0 /-6.921d0/
      DATA sssna /1.9000/
      DATA sssnb /1.9000/
      DATA sssnc /9.000/
c p s sigma
      DATA pss0 /-5.594/
      DATA pssna /1.6030/
      DATA pssnb /1.6030/
      DATA pssnc /9.000/
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
      call wangma(sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)
      call wangma(pss0,r0,pssna,pssnb,rt,pssnc,pss,dpss)
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxyz('x',pss,dpss,t,dt)       !px-s
      hamil(2,1)=t
      dhamil(2,1,1)=dt(1)
      dhamil(2,1,2)=dt(2)
      dhamil(2,1,3)=dt(3)

      call sxyz('y',pss,dpss,t,dt)       !py-s
      hamil(3,1)=t
      dhamil(3,1,1)=dt(1)
      dhamil(3,1,2)=dt(2)
      dhamil(3,1,3)=dt(3)

      call sxyz('z',pss,dpss,t,dt)       !pz-s
      hamil(4,1)=t
      dhamil(4,1,1)=dt(1)
      dhamil(4,1,2)=dt(2)
      dhamil(4,1,3)=dt(3)
 
      return
      end
