c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and Ni.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine c_trhd (ip,hamil,dhamil)
c
      implicit none
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3),vsip(8,2)
      integer ip,jp,i
      integer sN(6),dN(6)
      double precision szetapm(6),pzetapm(6),szeta(6)
      double precision sss,dsss,sds,dsds,pss,dpss,pds,dpds,pdp,dpdp
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)
      double precision r,k(6),r0(6),mu0(6)
      double precision dkllp,kllp,x,param(20)
      double precision tmp1,tmp2,tmp3,tmp4,temp,intgr,dintgr

      common /coulom/ vsip
      common /distan/ r
c
c STO parameters for carbon element
c
      DATA (szetapm(i),i=1,6)/1.56068,1.13260,1.59663,1.52369,
     &                        1.57727,1.25328/
      DATA (pzetapm(i),i=1,6)/1.56068,1.13260,1.59663,1.52369,
     &                        1.57727,1.25328/
c
c STO parameters for transition element
c
      DATA (sN(i),i=1,6) /4,4,5,5,6,6/
      DATA (dN(i),i=1,6) /3,3,4,4,5,5/
      DATA (szeta(i),i=1,6) /1.46952,2.14462,1.75195,1.81756,
     &                       2.04336,2.53186/
      DATA (coef1(i),i=1,6) /0.58579,0.59552,0.54226,0.56019,
     &                       0.65678,0.64695/
      DATA (coef2(i),i=1,6) /0.64856,0.57655,0.65649,0.55617,
     &                       0.57165,0.53788/
      DATA (dzeta1(i),i=1,6) /5.39452,5.89462,5.54495 ,4.90056,
     &                       5.50236,5.89462/
      DATA (dzeta2(i),i=1,6) /1.64452,2.24462,2.17495,2.49556,
     &                        2.18536,2.24462/
c
c Wolfberg-Holmholz constants
c
      DATA (  k(i),i=1,6) /0.26441,0.18125,0.29889,0.20342,
     &                     0.34261,0.30277/
      DATA ( r0(i),i=1,6) /1.9928 ,1.2870 ,2.9265,1.5743,
     &                     2.0176 ,2.9275/
      DATA (mu0(i),i=1,6) /0.01756,1.27014,0.04703,1.37253,
     &                     0.01994,0.67298/
c
      jp=ip-2
c
      temp=k(jp)*(r/r0(jp))**mu0(jp)
      kllp=k(jp)+temp
      dkllp=mu0(jp)*temp/r
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
c Actually, the final result is the product of overlap integral and constant
c K (distance dependent).
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(2,0,szetapm(jp),sN(jp),0,0,szeta(jp),intgr,dintgr)
      dsss=dintgr*kllp+intgr*dkllp
       sss= intgr*kllp
c
c p s sigma bonding overlap integral in z-axis
c
      call ovlcon(2,1,pzetapm(jp),sN(jp),0,0,szeta(jp),intgr,dintgr)
      dpss=dintgr*kllp+intgr*dkllp
       pss=intgr*kllp
c
c s d sigma bonding overlap integral in z-axis
c
      call ovlcon(2,0,szetapm(jp),dN(jp),2,0,dzeta1(jp),intgr,dintgr)
       sds= intgr*coef1(jp)
      dsds=dintgr*coef1(jp)

      call ovlcon(2,0,szetapm(jp),dN(jp),2,0,dzeta2(jp),intgr,dintgr)
       sds= intgr*coef2(jp)+ sds
      dsds=dintgr*coef2(jp)+dsds
c
      dsds=dsds*kllp+sds*dkllp
       sds= sds*kllp
c
c p d sigma bonding overlap integral in z-axis
c
      call ovlcon(2,1,pzetapm(jp),dN(jp),2,0,dzeta1(jp),intgr,dintgr)
       pds= intgr*coef1(jp)
      dpds=dintgr*coef1(jp)

      call ovlcon(2,1,pzetapm(jp),dN(jp),2,0,dzeta2(jp),intgr,dintgr)
       pds= intgr*coef2(jp)+ pds
      dpds=dintgr*coef2(jp)+dpds
c
      dpds=dpds*kllp+pds*dkllp
       pds= pds*kllp
c
c p d pi bonding overlap integral in z-axis
c
      call ovlcon(2,1,pzetapm(jp),dN(jp),2,1,dzeta1(jp),intgr,dintgr)
       pdp= intgr*coef1(jp)
      dpdp=dintgr*coef1(jp)

      call ovlcon(2,1,pzetapm(jp),dN(jp),2,1,dzeta2(jp),intgr,dintgr)
       pdp= intgr*coef2(jp)+ pdp
      dpdp=dintgr*coef2(jp)+dpdp
c
      dpdp=dpdp*kllp+pdp*dkllp
       pdp= pdp*kllp
c
c Multiply kmn with (Hm(Ni)+Hn(C))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(2,1)+vsip(ip,1))/2.0
      tmp2=(vsip(2,1)+vsip(ip,2))/2.0
      tmp3=(vsip(2,2)+vsip(ip,1))/2.0
      tmp4=(vsip(2,2)+vsip(ip,2))/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxy('xy',sds,dsds,t,dt)       !s-dxy
      hamil(1,2)=t*tmp2
      dhamil(1,2,1)=dt(1)*tmp2
      dhamil(1,2,2)=dt(2)*tmp2
      dhamil(1,2,3)=dt(3)*tmp2

      call sxy('yz',sds,dsds,t,dt)       !s-dyz
      hamil(1,3)=t*tmp2
      dhamil(1,3,1)=dt(1)*tmp2
      dhamil(1,3,2)=dt(2)*tmp2
      dhamil(1,3,3)=dt(3)*tmp2

      call sxy('zx',sds,dsds,t,dt)       !s-dzx
      hamil(1,4)=t*tmp2
      dhamil(1,4,1)=dt(1)*tmp2
      dhamil(1,4,2)=dt(2)*tmp2
      dhamil(1,4,3)=dt(3)*tmp2

      call sxxyy(sds,dsds,t,dt)          !s-dx2_y2
      hamil(1,5)=t*tmp2
      dhamil(1,5,1)=dt(1)*tmp2
      dhamil(1,5,2)=dt(2)*tmp2
      dhamil(1,5,3)=dt(3)*tmp2

      call szz(sds,dsds,t,dt)            !s-dz2
      hamil(1,6)=t*tmp2
      dhamil(1,6,1)=dt(1)*tmp2
      dhamil(1,6,2)=dt(2)*tmp2
      dhamil(1,6,3)=dt(3)*tmp2

      call sxyz('x',pss,dpss,t,dt)       !px-s 
      hamil(2,1)=t*tmp3
      dhamil(2,1,1)=dt(1)*tmp3
      dhamil(2,1,2)=dt(2)*tmp3
      dhamil(2,1,3)=dt(3)*tmp3

      call xxy('xy',pds,dpds,pdp,dpdp,t,dt)         !px-dxy
      hamil(2,2)=t*tmp4
      dhamil(2,2,1)=dt(1)*tmp4
      dhamil(2,2,2)=dt(2)*tmp4
      dhamil(2,2,3)=dt(3)*tmp4

      call xyz(pds,dpds,pdp,dpdp,t,dt)              !px-dyz
      hamil(2,3)=t*tmp4
      dhamil(2,3,1)=dt(1)*tmp4
      dhamil(2,3,2)=dt(2)*tmp4
      dhamil(2,3,3)=dt(3)*tmp4

      call xxy('xz',pds,dpds,pdp,dpdp,t,dt)         !px-dzx
      hamil(2,4)=t*tmp4
      dhamil(2,4,1)=dt(1)*tmp4
      dhamil(2,4,2)=dt(2)*tmp4
      dhamil(2,4,3)=dt(3)*tmp4

      call xxxyy(pds,dpds,pdp,dpdp,t,dt)            !px-dx2_y2
      hamil(2,5)=t*tmp4
      dhamil(2,5,1)=dt(1)*tmp4
      dhamil(2,5,2)=dt(2)*tmp4
      dhamil(2,5,3)=dt(3)*tmp4

      call xzz('x',pds,dpds,pdp,dpdp,t,dt)              !px-dz2
      hamil(2,6)=t*tmp4
      dhamil(2,6,1)=dt(1)*tmp4
      dhamil(2,6,2)=dt(2)*tmp4
      dhamil(2,6,3)=dt(3)*tmp4

      call sxyz('y',pss,dpss,t,dt)       !py-s 
      hamil(3,1)=t*tmp3
      dhamil(3,1,1)=dt(1)*tmp3
      dhamil(3,1,2)=dt(2)*tmp3
      dhamil(3,1,3)=dt(3)*tmp3

      call xxy('yx',pds,dpds,pdp,dpdp,t,dt)         !py-dxy
      hamil(3,2)=t*tmp4
      dhamil(3,2,1)=dt(1)*tmp4
      dhamil(3,2,2)=dt(2)*tmp4
      dhamil(3,2,3)=dt(3)*tmp4

      call xxy('yz',pds,dpds,pdp,dpdp,t,dt)         !py-dyz
      hamil(3,3)=t*tmp4
      dhamil(3,3,1)=dt(1)*tmp4
      dhamil(3,3,2)=dt(2)*tmp4
      dhamil(3,3,3)=dt(3)*tmp4

      call xyz(pds,dpds,pdp,dpdp,t,dt)              !py-dzx
      hamil(3,4)=t*tmp4
      dhamil(3,4,1)=dt(1)*tmp4
      dhamil(3,4,2)=dt(2)*tmp4
      dhamil(3,4,3)=dt(3)*tmp4

      call yxxyy(pds,dpds,pdp,dpdp,t,dt)            !py-dx2_y2
      hamil(3,5)=t*tmp4
      dhamil(3,5,1)=dt(1)*tmp4
      dhamil(3,5,2)=dt(2)*tmp4
      dhamil(3,5,3)=dt(3)*tmp4

      call xzz('y',pds,dpds,pdp,dpdp,t,dt)              !py-dz2
      hamil(3,6)=t*tmp4
      dhamil(3,6,1)=dt(1)*tmp4
      dhamil(3,6,2)=dt(2)*tmp4
      dhamil(3,6,3)=dt(3)*tmp4

      call sxyz('z',pss,dpss,t,dt)       !pz-s 
      hamil(4,1)=t*tmp3
      dhamil(4,1,1)=dt(1)*tmp3
      dhamil(4,1,2)=dt(2)*tmp3
      dhamil(4,1,3)=dt(3)*tmp3

      call xyz(pds,dpds,pdp,dpdp,t,dt)               !pz-dxy
      hamil(4,2)=t*tmp4
      dhamil(4,2,1)=dt(1)*tmp4
      dhamil(4,2,2)=dt(2)*tmp4
      dhamil(4,2,3)=dt(3)*tmp4

      call xxy('zy',pds,dpds,pdp,dpdp,t,dt)          !pz-dyz
      hamil(4,3)=t*tmp4
      dhamil(4,3,1)=dt(1)*tmp4
      dhamil(4,3,2)=dt(2)*tmp4
      dhamil(4,3,3)=dt(3)*tmp4

      call xxy('zx',pds,dpds,pdp,dpdp,t,dt)          !pz-dzx
      hamil(4,4)=t*tmp4
      dhamil(4,4,1)=dt(1)*tmp4
      dhamil(4,4,2)=dt(2)*tmp4
      dhamil(4,4,3)=dt(3)*tmp4

      call zxxyy(pds,dpds,pdp,dpdp,t,dt)             !pz-dx2_y2
      hamil(4,5)=t*tmp4
      dhamil(4,5,1)=dt(1)*tmp4
      dhamil(4,5,2)=dt(2)*tmp4
      dhamil(4,5,3)=dt(3)*tmp4

      call zzz(pds,dpds,pdp,dpdp,t,dt)               !pz-dz2
      hamil(4,6)=t*tmp4
      dhamil(4,6,1)=dt(1)*tmp4
      dhamil(4,6,2)=dt(2)*tmp4
      dhamil(4,6,3)=dt(3)*tmp4

      return
      end
