c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the pairwise repulsion and the first    
c derivatives of the repulsive energy between Ni and C or C and Ni.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine ctrcrp (ip,repul,drepul)
c
      implicit none
      integer i,ip,jp
      double precision repul,dt,drepul(3)
      double precision l,m,n,lladmm,llmimm,nn,r
      double precision alphap(6),betap(6),gammap(6)
c
      common /lmn/ l,m,n,lladmm,llmimm,nn
c
c Repulsive parameters for transition metal-carbon
c
      DATA (alphap(i),i=1,6) /1846.09,3760.37,2884.69,2145.03,
     &                        2725.73,3413.9 /
      DATA (betap(i), i=1,6) /4.3979 ,5.4333 ,4.2078 ,4.3155 ,
     &                        4.5494,4.5461/
      DATA (gammap(i),i=1,6) /0.28764,1.20464,0.20619,0.73337,
     &                        1.07947 ,0.79440/
c
      jp=ip-2
c
      call grepfm (alphap(jp),gammap(jp),betap(jp),repul,dt)
      
      drepul(1)=dt*l
      drepul(2)=dt*m
      drepul(3)=dt*n
 
      return
      end
