c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine h_c_hd (hamil,dhamil)
c
      implicit none
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3)
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
      double precision sps0,   spsna,spsnb,   spsnc,sps,dsps
c
c Hopping parameters for hydrogen-carbon from Wang and Mak.
c
      DATA r0 /1.09d0/
      DATA rt /2.d0/
c s s sigma
      DATA sss0 /-6.921d0/
      DATA sssna /1.9000/
      DATA sssnb /1.9000/
      DATA sssnc /9.000/
c s p sigma
      DATA sps0 /5.594d0/
      DATA spsna /1.603d0/
      DATA spsnb /1.603d0/
      DATA spsnc /9.0/
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
      call wangma(sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)
      call wangma(sps0,r0,spsna,spsnb,rt,spsnc,sps,dsps)
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxyz('x',sps,dsps,t,dt)       !s-px
      hamil(1,2)=t
      dhamil(1,2,1)=dt(1)
      dhamil(1,2,2)=dt(2)
      dhamil(1,2,3)=dt(3)

      call sxyz('y',sps,dsps,t,dt)       !s-py
      hamil(1,3)=t
      dhamil(1,3,1)=dt(1)
      dhamil(1,3,2)=dt(2)
      dhamil(1,3,3)=dt(3)

      call sxyz('z',sps,dsps,t,dt)       !s-pz
      hamil(1,4)=t
      dhamil(1,4,1)=dt(1)
      dhamil(1,4,2)=dt(2)
      dhamil(1,4,3)=dt(3)
 
      return
      end
