c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between H and H.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine h_h_hd (hamil,dhamil)
c
      implicit none
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3)
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
c
c Hopping parameters for hydrogen-hydrogen
c
      DATA r0 /0.7414d0/
      DATA rt /4.176d0/
      DATA sss0 /-4.842d0/
      DATA sssna /2.049D0/
      DATA sssnb /1.762D0/
      DATA sssnc /5.609d0/
c
      call wangma(sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)
c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
      call ss(sss,dsss,t,dt)     !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)
 
      return
      end
