c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between H and Ni.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine h_trhd (ip,hamil,dhamil)
c
      implicit none
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3),vsip(8,2)
      integer ip,jp,i,j
      integer sN(6),dN(6)
      double precision szetapm(6),szeta(6)
      double precision sss,dsss,sds,dsds
      double precision kss(6),ksd(6)
      double precision tmp1,tmp2,intgr,dintgr
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)

      common /coulom/ vsip
c
c STO parameters for hydrogen element
c
      DATA (szetapm(i),i=1,6) /1.22576,1.26397,1.21011,1.23966,
     &                         1.25792,1.12836/
c
c STO parameters for transition elements
c
      DATA (sN(i),i=1,6) /4,4,5,5,6,6/
      DATA (dN(i),i=1,6) /3,3,4,4,5,5/
      DATA (szeta(i),i=1,6) /1.76329,1.81529,2.03423,1.74711,
     &                       2.36819,2.12506/
      DATA (coef1(i),i=1,6) /0.57107,0.61029,0.53160,0.56239,
     &                       0.64119,0.66519/
      DATA (coef2(i),i=1,6) /0.63227,0.59085,0.64359,0.55836,
     &                       0.55808,0.55304/
      DATA (dzeta1(i),i=1,6) /5.68829,5.56529,5.82723,4.83011,
     &                       5.82719,5.68606/
      DATA (dzeta2(i),i=1,6) /1.93829,1.91529,2.45723,2.42511,
     &                       2.51109,2.31706/
c
c Wolfberg-Holmholz constants
c
      DATA (kss(i),i=1,6) /0.75730 ,0.80843,0.67048,0.57090,
     &                     0.91655 ,0.61968/
      DATA (ksd(i),i=1,6) /0.18030 ,0.02514,0.03081,0.05065,
     &                     0.31296 ,0.003524/
c
      jp=ip-2
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(1,0,szetapm(jp),sN(jp),0,0,szeta(jp),intgr,dintgr)
       sss=intgr
      dsss=dintgr

c s d sigma bonding overlap integral in z-axis
c        
      call ovlcon(1,0,szetapm(jp),dN(jp),2,0,dzeta1(jp),intgr,dintgr)
       sds= intgr*coef1(jp)
      dsds=dintgr*coef1(jp)

      call ovlcon(1,0,szetapm(jp),dN(jp),2,0,dzeta2(jp),intgr,dintgr)
       sds= intgr*coef2(jp)+ sds
      dsds=dintgr*coef2(jp)+dsds
c
c Multiply kmn with (Hm(Ni)+Hn(H))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(ip,1)+vsip(1,1))*kss(jp)/2.0
      tmp2=(vsip(ip,2)+vsip(1,1))*ksd(jp)/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxy('xy',sds,dsds,t,dt)       !s-dxy
      hamil(1,2)=t*tmp2
      dhamil(1,2,1)=dt(1)*tmp2
      dhamil(1,2,2)=dt(2)*tmp2
      dhamil(1,2,3)=dt(3)*tmp2

      call sxy('yz',sds,dsds,t,dt)       !s-dyz
      hamil(1,3)=t*tmp2
      dhamil(1,3,1)=dt(1)*tmp2
      dhamil(1,3,2)=dt(2)*tmp2
      dhamil(1,3,3)=dt(3)*tmp2

      call sxy('zx',sds,dsds,t,dt)       !s-dzx
      hamil(1,4)=t*tmp2
      dhamil(1,4,1)=dt(1)*tmp2
      dhamil(1,4,2)=dt(2)*tmp2
      dhamil(1,4,3)=dt(3)*tmp2

      call sxxyy(sds,dsds,t,dt)          !s-dx2_y2
      hamil(1,5)=t*tmp2
      dhamil(1,5,1)=dt(1)*tmp2
      dhamil(1,5,2)=dt(2)*tmp2
      dhamil(1,5,3)=dt(3)*tmp2

      call szz(sds,dsds,t,dt)            !s-dz2
      hamil(1,6)=t*tmp2
      dhamil(1,6,1)=dt(1)*tmp2
      dhamil(1,6,2)=dt(2)*tmp2
      dhamil(1,6,3)=dt(3)*tmp2

      return
      end
