c
c This is a subroutine to compute the overlap integral between s orbital and
c s orbital when the directional cosines of the two atoms is l, m, and n.
c
c In sss the first s means s orbital (angular quantum number is 0), the second
c s means s orbital (angular quantum number is 0), and the third s means sigma
c bonding (the magnetic quantum number for the two orbitals is 0, otherwise
c the sss is 0).
c

      subroutine ss(sss,dsss,hamil,dhamil)

      implicit none
      double precision sss,dsss,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following common blocks give the directional cosines and some 
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      hamil=sss

      dhamil(1)=dsss*l
      dhamil(2)=dsss*m
      dhamil(3)=dsss*n

      return
      end
