c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between Ni and C.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine trc_hd (ip,hamil,dhamil)
c
      implicit none
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3),vsip(8,2)
      integer ip,jp,i
      integer sNp(6),dNp(6)
      double precision szetapm(6),szeta(6),pzeta(6)
      double precision sss,dsss,dss,ddss,sps,dsps,dps,ddps,dpp,ddpp
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)
      double precision r,k(6),r0(6),mu0(6)
      double precision dkllp,kllp,x
      double precision tmp1,tmp2,tmp3,tmp4,temp,intgr,dintgr
c
      common /coulom/ vsip
      common /distan/ r
c
c STO parameters for transition element
c
      DATA (sNp(i),i=1,6) /4,4,5,5,6,6/
      DATA (dNp(i),i=1,6) /3,3,4,4,5,5/
      DATA (szetapm(i),i=1,6) /1.46952,2.14462,1.75195,1.81756,
     &                         2.04336,2.53186/
      DATA (coef1(i),i=1,6) /0.58579,0.59552,0.54226,0.56019,
     &                       0.65678,0.64695/
      DATA (coef2(i),i=1,6) /0.64856,0.57655,0.65649,0.55617,
     &                       0.57165,0.53788/
      DATA (dzeta1(i),i=1,6) /5.39452,5.89462,5.54495,4.90056,
     &                       5.50236,6.09286/
      DATA (dzeta2(i),i=1,6) /1.64452,2.24462,2.17495,2.49556,
     &                       2.18536,2.72386/
c
c STO parameters for carbon element
c
      DATA (szeta(i),i=1,6) /1.56068,1.13260,1.59663,1.52369,
     &                       1.57727,1.25328/
      DATA (pzeta(i),i=1,6) /1.56068,1.13260,1.59663,1.52369,
     &                       1.57727,1.25328/
c
c Wolfberg-Holmholz constants
c
      DATA (  k(i),i=1,6) /0.26441,0.18125,0.29889,0.20342,
     &                     0.34261,0.30277/
      DATA ( r0(i),i=1,6) /1.9928 ,1.2870,2.9265,1.5743,
     &                     2.0176 ,2.9275/
      DATA (mu0(i),i=1,6) /0.01756,1.27014,0.04703,1.37253,
     &                     0.01994,0.67298/
c
      jp=ip-2
c
      temp=k(jp)*(r/r0(jp))**mu0(jp)
      kllp=k(jp)+temp
      dkllp=mu0(jp)*temp/r
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c Actually, the final result is the product of overlap integral and constant
c K (distance dependent).
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(sNp(jp),0,szetapm(jp),2,0,0,szeta(jp),intgr,dintgr)
      dsss=dintgr*kllp+intgr*dkllp
       sss= intgr*kllp

c d s sigma bonding overlap integral in z-axis
c
      call ovlcon(dNp(jp),2,dzeta1(jp),2,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef1(jp)
      ddss=dintgr*coef1(jp)

      call ovlcon(dNp(jp),2,dzeta2(jp),2,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef2(jp)+ dss
      ddss=dintgr*coef2(jp)+ddss
c
      ddss=ddss*kllp+dss*dkllp
       dss= dss*kllp
c
c s p sigma bonding overlap integral in z-axis
c
      call ovlcon(sNp(jp),0,szetapm(jp),2,1,0,pzeta(jp),intgr,dintgr)
      dsps=dintgr*kllp+intgr*dkllp
       sps=intgr*kllp

c d p sigma bonding overlap integral in z-axis
c
      call ovlcon(dNp(jp),2,dzeta1(jp),2,1,0,pzeta(jp),intgr,dintgr)
       dps= intgr*coef1(jp)
      ddps=dintgr*coef1(jp)

      call ovlcon(dNp(jp),2,dzeta2(jp),2,1,0,pzeta(jp),intgr,dintgr)
       dps= intgr*coef2(jp)+ dps
      ddps=dintgr*coef2(jp)+ddps
c
      ddps=ddps*kllp+dps*dkllp
       dps= dps*kllp

c d p pi bonding overlap integral in z-axis
c
      call ovlcon(dNp(jp),2,dzeta1(jp),2,1,1,pzeta(jp),intgr,dintgr)
       dpp= intgr*coef1(jp)
      ddpp=dintgr*coef1(jp)

      call ovlcon(dNp(jp),2,dzeta2(jp),2,1,1,pzeta(jp),intgr,dintgr)
       dpp= intgr*coef2(jp)+ dpp
      ddpp=dintgr*coef2(jp)+ddpp
c
      ddpp=ddpp*kllp+dpp*dkllp
       dpp= dpp*kllp
c
c Multiply kmn with (Hm(Ni)+Hn(C))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(ip,1)+vsip(2,1))/2.0
      tmp2=(vsip(ip,1)+vsip(2,2))/2.0
      tmp3=(vsip(ip,2)+vsip(2,1))/2.0
      tmp4=(vsip(ip,2)+vsip(2,2))/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxyz('x',sps,dsps,t,dt)       !s-px 
      hamil(1,2)=t*tmp2
      dhamil(1,2,1)=dt(1)*tmp2
      dhamil(1,2,2)=dt(2)*tmp2
      dhamil(1,2,3)=dt(3)*tmp2

      call sxyz('y',sps,dsps,t,dt)       !s-py 
      hamil(1,3)=t*tmp2
      dhamil(1,3,1)=dt(1)*tmp2
      dhamil(1,3,2)=dt(2)*tmp2
      dhamil(1,3,3)=dt(3)*tmp2

      call sxyz('z',sps,dsps,t,dt)       !s-pz 
      hamil(1,4)=t*tmp2
      dhamil(1,4,1)=dt(1)*tmp2
      dhamil(1,4,2)=dt(2)*tmp2
      dhamil(1,4,3)=dt(3)*tmp2

      call sxy('xy',dss,ddss,t,dt)       !dxy-s
      hamil(2,1)=t*tmp3
      dhamil(2,1,1)=dt(1)*tmp3
      dhamil(2,1,2)=dt(2)*tmp3
      dhamil(2,1,3)=dt(3)*tmp3

      call xxy('xy',dps,ddps,dpp,ddpp,t,dt)         !dxy-px
      hamil(2,2)=t*tmp4
      dhamil(2,2,1)=dt(1)*tmp4
      dhamil(2,2,2)=dt(2)*tmp4
      dhamil(2,2,3)=dt(3)*tmp4

      call xxy('yx',dps,ddps,dpp,ddpp,t,dt)         !dxy-py
      hamil(2,3)=t*tmp4
      dhamil(2,3,1)=dt(1)*tmp4
      dhamil(2,3,2)=dt(2)*tmp4
      dhamil(2,3,3)=dt(3)*tmp4

      call xyz(dps,ddps,dpp,ddpp,t,dt)               !dxy-pz
      hamil(2,4)=t*tmp4
      dhamil(2,4,1)=dt(1)*tmp4
      dhamil(2,4,2)=dt(2)*tmp4
      dhamil(2,4,3)=dt(3)*tmp4

      call sxy('yz',dss,ddss,t,dt)       !dyz-s
      hamil(3,1)=t*tmp3
      dhamil(3,1,1)=dt(1)*tmp3
      dhamil(3,1,2)=dt(2)*tmp3
      dhamil(3,1,3)=dt(3)*tmp3

      call xyz(dps,ddps,dpp,ddpp,t,dt)              !dyz-px
      hamil(3,2)=t*tmp4
      dhamil(3,2,1)=dt(1)*tmp4
      dhamil(3,2,2)=dt(2)*tmp4
      dhamil(3,2,3)=dt(3)*tmp4

      call xxy('yz',dps,ddps,dpp,ddpp,t,dt)         !dyz-py
      hamil(3,3)=t*tmp4
      dhamil(3,3,1)=dt(1)*tmp4
      dhamil(3,3,2)=dt(2)*tmp4
      dhamil(3,3,3)=dt(3)*tmp4

      call xxy('zy',dps,ddps,dpp,ddpp,t,dt)          !dyz-pz
      hamil(3,4)=t*tmp4
      dhamil(3,4,1)=dt(1)*tmp4
      dhamil(3,4,2)=dt(2)*tmp4
      dhamil(3,4,3)=dt(3)*tmp4

      call sxy('zx',dss,ddss,t,dt)       !dzx-s
      hamil(4,1)=t*tmp3
      dhamil(4,1,1)=dt(1)*tmp3
      dhamil(4,1,2)=dt(2)*tmp3
      dhamil(4,1,3)=dt(3)*tmp3

      call xxy('xz',dps,ddps,dpp,ddpp,t,dt)         !dzx-px
      hamil(4,2)=t*tmp4
      dhamil(4,2,1)=dt(1)*tmp4
      dhamil(4,2,2)=dt(2)*tmp4
      dhamil(4,2,3)=dt(3)*tmp4

      call xyz(dps,ddps,dpp,ddpp,t,dt)              !dzx-py
      hamil(4,3)=t*tmp4
      dhamil(4,3,1)=dt(1)*tmp4
      dhamil(4,3,2)=dt(2)*tmp4
      dhamil(4,3,3)=dt(3)*tmp4

      call xxy('zx',dps,ddps,dpp,ddpp,t,dt)          !dzx-pz
      hamil(4,4)=t*tmp4
      dhamil(4,4,1)=dt(1)*tmp4
      dhamil(4,4,2)=dt(2)*tmp4
      dhamil(4,4,3)=dt(3)*tmp4

      call sxxyy(dss,ddss,t,dt)          !dx2_y2-s
      hamil(5,1)=t*tmp3
      dhamil(5,1,1)=dt(1)*tmp3
      dhamil(5,1,2)=dt(2)*tmp3
      dhamil(5,1,3)=dt(3)*tmp3

      call xxxyy(dps,ddps,dpp,ddpp,t,dt)            !dx2_y2-px
      hamil(5,2)=t*tmp4
      dhamil(5,2,1)=dt(1)*tmp4
      dhamil(5,2,2)=dt(2)*tmp4
      dhamil(5,2,3)=dt(3)*tmp4

      call yxxyy(dps,ddps,dpp,ddpp,t,dt)            !dx2_y2-py
      hamil(5,3)=t*tmp4
      dhamil(5,3,1)=dt(1)*tmp4
      dhamil(5,3,2)=dt(2)*tmp4
      dhamil(5,3,3)=dt(3)*tmp4

      call zxxyy(dps,ddps,dpp,ddpp,t,dt)             !dx2_y2-pz
      hamil(5,4)=t*tmp4
      dhamil(5,4,1)=dt(1)*tmp4
      dhamil(5,4,2)=dt(2)*tmp4
      dhamil(5,4,3)=dt(3)*tmp4

      call szz(dss,ddss,t,dt)            !dz2-s
      hamil(6,1)=t*tmp3
      dhamil(6,1,1)=dt(1)*tmp3
      dhamil(6,1,2)=dt(2)*tmp3
      dhamil(6,1,3)=dt(3)*tmp3

      call xzz('x',dps,ddps,dpp,ddpp,t,dt)              !dz2-px
      hamil(6,2)=t*tmp4
      dhamil(6,2,1)=dt(1)*tmp4
      dhamil(6,2,2)=dt(2)*tmp4
      dhamil(6,2,3)=dt(3)*tmp4

      call xzz('y',dps,ddps,dpp,ddpp,t,dt)              !dz2-py
      hamil(6,3)=t*tmp4
      dhamil(6,3,1)=dt(1)*tmp4
      dhamil(6,3,2)=dt(2)*tmp4
      dhamil(6,3,3)=dt(3)*tmp4

      call zzz(dps,ddps,dpp,ddpp,t,dt)               !dz2-pz
      hamil(6,4)=t*tmp4
      dhamil(6,4,1)=dt(1)*tmp4
      dhamil(6,4,2)=dt(2)*tmp4
      dhamil(6,4,3)=dt(3)*tmp4

      return
      end
