c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine trh_hd (ip,hamil,dhamil)
c
      implicit none
      double precision hamil(6,6),dhamil(6,6,3),t,dt(3),vsip(8,2)
      integer ip,jp,i
      integer sNp(6),dNp(6)
      double precision szetapm(6),szeta(6)
      double precision sss,dsss,dss,ddss
      double precision kss(6),kds(6)
      double precision tmp1,tmp2,intgr,dintgr
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)

      common /coulom/ vsip
c
c STO parameters for transition element
c
      DATA (sNp(i),i=1,6) /4,4,5,5,6,6/
      DATA (dNp(i),i=1,6) /3,3,4,4,5,5/
      DATA (szetapm(i),i=1,6) /1.76329,1.81529,2.03423,1.74711,
     &                         2.36819,2.12506/
      DATA (coef1(i),i=1,6) /0.57107,0.61029,0.53160,0.56239,
     &                       0.64119,0.66519/
      DATA (coef2(i),i=1,6) /0.63227,0.59085,0.64359,0.55836,
     &                       0.55808,0.55304/
      DATA (dzeta1(i),i=1,6) /5.68829,5.56529,5.82723,4.83011,
     &                       5.82719,5.68606/
      DATA (dzeta2(i),i=1,6) /1.93829,1.91529,2.45723,2.42511,
     &                       2.51019,2.31706/
c
c STO parameters for hydrogen element
c
      DATA (szeta(i),i=1,6) /1.22576,1.26397,1.21011,1.23966,
     &                       1.25792,1.12836/
c
c Wolfberg-Hol relation k constant.
c
      DATA (kss(i),i=1,6) /0.75730 ,0.80843,0.67048,0.57090,
     &                     0.91655,0.61968/
      DATA (kds(i),i=1,6) /0.18030 ,0.02514,0.03081,0.05065,
     &                     0.31296,0.003524/
c
      jp=ip-2
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(sNp(jp),0,szetapm(jp),1,0,0,szeta(jp),intgr,dintgr)
       sss=intgr
      dsss=dintgr

c d s sigma bonding overlap integral in z-axis
c
      call ovlcon(dNp(jp),2,dzeta1(jp),1,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef1(jp)
      ddss=dintgr*coef1(jp)

      call ovlcon(dNp(jp),2,dzeta2(jp),1,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef2(jp)+ dss
      ddss=dintgr*coef2(jp)+ddss
c
c Multiply kmn with (Hm(Ni)+Hn(H))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(ip,1)+vsip(1,1))*kss(jp)/2.0
      tmp2=(vsip(ip,2)+vsip(1,1))*kds(jp)/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)                          !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxy('xy',dss,ddss,t,dt)                    !dxy-s
      hamil(2,1)=t*tmp2
      dhamil(2,1,1)=dt(1)*tmp2
      dhamil(2,1,2)=dt(2)*tmp2
      dhamil(2,1,3)=dt(3)*tmp2

      call sxy('yz',dss,ddss,t,dt)                    !dyz-s
      hamil(3,1)=t*tmp2
      dhamil(3,1,1)=dt(1)*tmp2
      dhamil(3,1,2)=dt(2)*tmp2
      dhamil(3,1,3)=dt(3)*tmp2

      call sxy('zx',dss,ddss,t,dt)                    !dzx-s
      hamil(4,1)=t*tmp2
      dhamil(4,1,1)=dt(1)*tmp2
      dhamil(4,1,2)=dt(2)*tmp2
      dhamil(4,1,3)=dt(3)*tmp2

      call sxxyy(dss,ddss,t,dt)                       !dx2_y2-s
      hamil(5,1)=t*tmp2
      dhamil(5,1,1)=dt(1)*tmp2
      dhamil(5,1,2)=dt(2)*tmp2
      dhamil(5,1,3)=dt(3)*tmp2

      call szz(dss,ddss,t,dt)                         !dz2-s
      hamil(6,1)=t*tmp2
      dhamil(6,1,1)=dt(1)*tmp2
      dhamil(6,1,2)=dt(2)*tmp2
      dhamil(6,1,3)=dt(3)*tmp2

      return
      end
